Subject: [Sip] AW: Why Proxies are Good and B2BUAs May Not Be --> NO NO NO

From: [email-masked]
Date: Tue, 26 Feb 2002 16:55:02 +0100

Hello,

just curious: how would you classify a 'gateway' (my termporary name)
that translates SIP-via-XML to and from SIP/2.0/UDP ? 
Would it be a proxy, iaw a 'good citizen'? 
Or would it be a B2BUA, a 'bad citizen' ?

If you say everything beyond a proxy is a sin, how would SIP itself 
ever evaluate further? Will it keep it is today forever? My doubts remain.

My personal view:
I personally feel the term SIP 'proxy' as badly chosen, as it implies 
that the usual connection model were end-to-end, very much like 
the original SMTP-model RFC821, where users would work as logged-in 
users on multi-user machines (SysVR4 whatever;). 
As with E-Mail, I would expect this model to vanish from the 
SIP-world, just like it is the far minority for SMTP nowadays.
So I'd rather call a SIP 'proxy' a SIP "server". 
Likewise I'd say a REGISTER will eventually be used like a 'LOGIN'.
In the RFC, one can easily imagine, that such a clarification would
put away a lot of puzzeling of terms in the REGISTER examples.

Regards,
Thomas Nagel

> -----Ursprüngliche Nachricht-----
> Von: Dean Willis [mailto:[email-masked]]
> Gesendet: Montag, 25. Februar 2002 05:49
> An: Gonzalo Camarillo; Cullen Jennings
> Cc: Bob Penfield; [email-masked]
> Betreff: Why Proxies are Good and B2BUAs May Not Be (was Re: [Sip]
> bis-07.9: proxies are not allowed to modify message body)
> 
> 
> Gonzalo wrote:
> > you have a
> > B2BUA... I do not see a problem with that.
> >
> > I think the problem everybody has with this MUST NOT is the 
> following.
> > People think: "If the elements in my architecture are 
> called proxies, I
> > have a very good architecture, but if the elements in my 
> architecture
> > are B2BUAs, my architecture is crap."... and to make every 
> architecture
> > look good, they want to call stretch the concep of proxy so that all
> > their elements are called "proxies".
> >
> > I do not think it is a big deal how we call these 
> elements... let's call
> > everything an OPES-element instead of "proxy" or "B2BUA" 
> and everybody
> > will be happy ;o)
> 
> Here's my worry about that. There are REASONS why proxies are 
> as limited as
> they are in the specification. It's to keep them from 
> breaking other things.
> This has come up time and time again in 3GPP -- almost every 
> time that we
> fudge the line between proxy and B2BUA, we end up breaking 
> something else.
> 
> The proxy rules are, I believe, most effective in providing "forward
> compatibility" -- a basic proxy will work, as expected, with 
> any reasonable
> future SIP extension method type, extension header, or 
> payload. In fact,
> that's part of the rule we use in determining "reasonableness" for
> extensions. No such restraint applies to B2BUAs. If you 
> "break the rules" of
> a proxy, all compatibility bets are off, and problems become 
> very likely.
> It's like running naked through Central Park at night with a 
> bunch of $20
> bills taped to your backside -- you MIGHT not have an 
> unfortunate encounter,
> and if you do you'll hear a whole lot of "I told you so!"s.
> 
> --
> Dean
> 
> 
> _______________________________________________
> Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> This list is for NEW development of the core SIP Protocol
> Use [email-masked] for questions on current sip
> Use [email-masked] for new developments on the application of sip
> 

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: "Dean Willis" <[email-masked]>
Date: Tue, 26 Feb 2002 10:42:30 -0600

> Or would it be a B2BUA, a 'bad citizen' ?

It's a "gateway".  From a SIP perspective, it's just a UA, just as a phone
is a UA that translates SIP and RTP to/from user interface and sound.

Other gateways include SIMPLE<->Jabber, SIP<->H.323,  SIMPLE<->AOL,
SIP<->SS7, and so on . . .

Gateways are Good Things, but it may not be possible to assure 100% SIP
feature transparency across a gateway.

Essentially, anything that does SIP->somethingelse->SIP can be considered a
form of B2BUA. Feature transparency across such a stucture requires a fully
homomorphic mapping between SIP and somethingelse. Any restrictions on that
mapping WILL break some kind of feature transaprency.

> ever evaluate further? Will it keep it is today forever? My doubts remain.

It's not a sin in my world view, but it is risky (just like surgery is). And
I believe at least one major religion declared surgery to be a sin once upon
a time  . . .

> So I'd rather call a SIP 'proxy' a SIP "server".

Actually, the idea is that that SIP proxy functions are very analagous to
SMTP relays. They apply some policy control, and forward messages on to
their destination using layer 4+ routing information with very little regard
for (and hopefully little alteration of) the actual content of the messages.

> put away a lot of puzzeling of terms in the REGISTER examples.

Yeah, this one really confuses people with a background in GSM mobile
phones, where registration IS "login". I probably spend two days a week
fighting this hydra, and it grows back its heads faster than  can burn them
off. My suggestion was to rename the REGISTER message "SETCONTACT", but the
lead editors for the spec were not amused.

--
Dean